<template lang="pug">
.el-table-wrapper

  el-table.block-typical.custom-table(
    v-loading='loading'
    :data='dataArray')

    el-table-column(
      label='ID'
      width='120')
        template(slot-scope='scope')
          span {{ scope.row.id }}

    el-table-column(
      v-if='columnNameWidth'
      :label='linkName.name'
      :width='columnNameWidth')
        template(slot-scope='scope')
          .technical-name__wrapper
            router-link.technical-name(:to='`${$route.path}/${scope.row.id}`')
              | {{ scope.row[linkName.attrName] }}

    el-table-column(
      v-for='(prop, index) in propDataGrid'
      :prop='prop.name'
      :label='prop.label'
      :width='prop.width'
      :key='index')

    el-table-column(
      v-if='activityView'
      prop='active'
      label='Активность'
      width='150')
      template(slot-scope='scope')
        span.active-icon(
          v-if='!scope.row.status'
          :class=' scope.row.active ? "success-icon" : "error-icon"')
          font-awesome-icon(
            :icon='scope.row.active ? "check-circle" : "times-circle"')

        span.active-icon(
          v-if='scope.row.status'
          :class='scope.row.status.code === 2 ? "success-icon" : "error-icon"')
          font-awesome-icon(
            :icon='scope.row.status.code === 2 ? "check-circle" : "times-circle"')

    el-table-column
      template(slot-scope='scope')
        el-popover.custom-table__edit-icon(
          placement='left-start'
          trigger='hover'
          v-model='scope.row.popoverView')
          div(style='text-align: right; margin: 0')
            .custom-table__popover-links

              router-link(
                :to='`${childComponent}${scope.row.id}`')
                  font-awesome-icon.custom-table__popover-icon(
                  icon='edit')
                  span.custom-table__popover-links-text Редактировать

              el-button(
                type='text'
                @click='dialogView(scope.row)')
                  span.custom-table__popover-links-text.custom-table__delete-button Удалить

          el-button(
            slot='reference'
            @click='scope.row.popoverView = true')
            font-awesome-icon(
              icon='ellipsis-v')

  .activity__block(v-if='paginationObj && paginationObj.totalPageCount > paginationObj.perPage')
    el-pagination(
      layout='prev, pager, next'
      @current-change='changePage'
      :current-page="paginationObj.currentPage"
      :page-size='paginationObj.perPage'
      :total='paginationObj ? paginationObj.totalPageCount : 0'
      background)

  el-dialog(
    title='Удаление'
    :visible.sync='dialogDeleteVisible')
    span.text-item Вы действительно хотите удалить&nbsp;
      span.h5.el-dialog__name-error {{dataItem.name}}
      |?
    span.dialog-footer(
      slot='footer')
      el-button.button(
        type='info'
        @click='dialogDeleteVisible = false'
        size='medium'
        round) Отмена
      el-button.button(
        type='danger'
        @click='deleteItem()'
        size='medium'
        round) Да, удалить


</template>

<script>
export default {
  name: 'DataGrid',
  props: {
    dataArray: {
      type: Array,
      required: true,
      default: () => []
    },
    paginationObj: {
      type: Object,
      required: false,
      default: () => null
    },
    changePage: {
      type: Function,
      required: true
    },
    columnNameWidth: {
      type: [Number, String],
      required: false,
      default: '530'
    },
    propDataGrid: {
      type: Array,
      required: false,
      default: () => []
    },
    activityView: {
      type: Boolean,
      required: false,
      default: false
    },
    loading: {
      type: Boolean,
      required: false,
      default: false
    },
    deletePermission: {
      type: String,
      required: false,
      default: 'isAdmin'
    },
    childComponent: {
      type: String,
      required: true
    },
    editPermission: {
      type: String,
      required: false,
      default: () => true
    },
    editParams: {
      type: String,
      required: false,
      default: 'edit'
    },
    linkName: {
      type: Object,
      required: false,
      default: () => {}
    }
  },
  data() {
    return {
      dialogDeleteVisible: false,
      dataItem: {}
    };
  },
  methods: {
    dialogView(item) {
      this.dataItem.id = item.id;
      this.dataItem.name =
        item['technical-name'] || item.email || item.name || item.heading;
      this.dialogDeleteVisible = true;
    },
    deleteItem() {
      this.$emit('delete-item', this.dataItem.id);
      this.dialogDeleteVisible = false;
      this.dataItem = {};
    }
  }
};
</script>
